## graphicsmagick 1.4+really1.3.38+hg16739

=== debian/changelog ===
graphicsmagick (1.4+really1.3.38+hg16739-1ubuntu0.1) kinetic-security; urgency=medium

  * No-change rebuild for jbigkit security update. 

 -- Camila Camargo de Matos <camila.camargodematos@canonical.com>  Wed, 15 Mar 2023 15:52:32 -0300

graphicsmagick (1.4+really1.3.38+hg16739-1) unstable; urgency=high

  * Mercurial snapshot, fixing the following security issue:
    - ReadSVGImage(): null pointer dereference by checking return from
      xmlCreatePushParserCtxt() .
  * Restore non-const Image::colorMapSize() since it caused an ABI change
    (closes: #1019158).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 06 Sep 2022 18:30:49 +0200

## graphicsmagick 1.4+really1.3.38+hg16870

=== debian/changelog ===
graphicsmagick (1.4+really1.3.38+hg16870-1) unstable; urgency=high

  * Mercurial snapshot, fixing several security issues.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 11 Dec 2022 07:59:31 +0100

=== debian/control ===
Source: graphicsmagick
Section: graphics
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper-compat (= 13), pkgconf, libjpeg-dev, liblcms2-dev,
 libwmf-dev (>= 0.2.8.4), libx11-dev, libsm-dev, libice-dev, libxext-dev,
 x11proto-core-dev, libxml2-dev, libfreetype6-dev, libbz2-dev, libtiff-dev,
 libjbig-dev, libpng-dev, libwebp-dev, libheif-dev, zlib1g-dev | libz-dev,
 libzstd-dev, perl, ghostscript,
 gsfonts <!nocheck>,
 sharutils <!nocheck>
Standards-Version: 4.5.1
Rules-Requires-Root: dpkg/target-subcommand
Homepage: http://www.graphicsmagick.org/

Package: graphicsmagick
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: graphicsmagick-doc, imagemagick (<< 6:6.2.4.4)
Suggests: graphicsmagick-dbg
Description: collection of image processing tools
 GraphicsMagick provides a set of command-line applications to manipulate
 image files. It is a fork of the ImageMagick project and therefore offers
 a similar set of features, but puts a larger emphasis on stability.
 .
 The tools support a large variety of image formats from the widely used
 jpeg, tiff, bmp or xpm to special-purpose formats such as fits or image
 formats found on some photo CDs. They can convert between formats,
 concatenate several images into one, annotate and distort them, create
 thumbnails or manipulate the colormap. While all features are available
 from the command-line, the package also includes an image viewer that
 allows interactive manipulation.
 .
 Note that unlike ImageMagick, the GraphicsMagick tools are accessed
 through a single executable called 'gm'. Therefore, GraphicsMagick and
 ImageMagick can be used in parallel. Install package
 graphicsmagick-imagemagick-compat to obtain a set of several executables
 that is compatible to ImageMagick's interface.

Package: libgraphicsmagick-q16-3
Architecture: any
Section: libs
Depends: libtiff5 (>= 4.0.10), ${shlibs:Depends}, ${misc:Depends}
Conflicts: libgraphicsmagick3 (>= 1.3.21)
Replaces: libgraphicsmagick3 (>= 1.3.21)
Recommends: ghostscript, gsfonts
Suggests: graphicsmagick-dbg
Description: format-independent image processing - C shared library
 GraphicsMagick provides libraries in several programming languages to read,
 write and manipulate image files across a large number of formats, from the
 widely used jpeg, tiff, bmp or xpm to special-purpose formats such as fits or
 image formats found on some photo CDs. There are functions for finegrained
 image processing tasks, as well as conversion routines between the various
 image formats.
 .
 The GraphicsMagick library is a fork of ImageMagick and therefore offers
 an interface that is similar in features, but intended to be more stable
 across releases. While compatibility does not go so far that the
 GraphicsMagick library serves as a drop-in replacement for ImageMagick,
 conversion can usually be done with little effort.
 .
 This package contains the C libraries needed to run executables that use
 the GraphicsMagick library.

Package: libgraphicsmagick1-dev
Architecture: any
Section: libdevel
Depends: libgraphicsmagick-q16-3 (= ${binary:Version}), libjpeg-dev,
 liblcms2-dev, libwmf-dev, libx11-dev, libsm-dev, libice-dev, libxext-dev,
 x11proto-core-dev, libxml2-dev, libfreetype6-dev, libtiff-dev (>= 4.0.10),
 libjbig-dev, libc6-dev, zlib1g-dev | libz-dev, libpng-dev, libheif-dev,
 libexif-dev, libbz2-dev, libltdl-dev, libwebp-dev, libzstd-dev, pkgconf,
 ${misc:Depends}
Breaks: libgraphicsmagick++1-dev (<< 1.3.21-2)
Suggests: graphicsmagick
Provides: libgraphicsmagick-dev
Description: format-independent image processing - C development files
 GraphicsMagick provides libraries in several programming languages to read,
 write and manipulate image files across a large number of formats, from the
 widely used jpeg, tiff, bmp or xpm to special-purpose formats such as fits or
 image formats found on some photo CDs. There are functions for finegrained
 image processing tasks, as well as conversion routines between the various
 image formats.
 .
 The GraphicsMagick library is a fork of ImageMagick and therefore offers
 an interface that is similar in features, but intended to be more stable
 across releases. While compatibility does not go so far that the
 GraphicsMagick library serves as a drop-in replacement for ImageMagick,
 conversion can usually be done with little effort.
 .
 This package contains the C development headers and library files needed to
 compile programs using the GraphicsMagick library.

Package: libgraphicsmagick++-q16-12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libgraphicsmagick++-q16-11 (= 1.3.22-1)
Replaces: libgraphicsmagick++-q16-11 (= 1.3.22-1)
Breaks: python-pgmagick (<= 0.7.4-1), python3-pgmagick (<= 0.7.4-1), libgnudatalanguage0 (<= 0.9.9-9)
Suggests: graphicsmagick-dbg
Description: format-independent image processing - C++ shared library
 GraphicsMagick provides libraries in several programming languages to read,
 write and manipulate image files across a large number of formats, from the
 widely used jpeg, tiff, bmp or xpm to special-purpose formats such as fits or
 image formats found on some photo CDs. There are functions for finegrained
 image processing tasks, as well as conversion routines between the various
 image formats.
 .
 The GraphicsMagick library is a fork of ImageMagick and therefore offers
 an interface that is similar in features, but intended to be more stable
 across releases. While compatibility does not go so far that the
 GraphicsMagick library serves as a drop-in replacement for ImageMagick,
 conversion can usually be done with little effort.
 .
 This package contains the C++ libraries needed to run executables that use
 the GraphicsMagick++ library.

Package: libgraphicsmagick++1-dev
Architecture: any
Section: libdevel
Depends: libgraphicsmagick++-q16-12 (= ${binary:Version}), libgraphicsmagick1-dev, ${misc:Depends}
Suggests: graphicsmagick
Provides: libgraphicsmagick++-dev
Description: format-independent image processing - C++ development files
 GraphicsMagick provides libraries in several programming languages to read,
 write and manipulate image files across a large number of formats, from the
 widely used jpeg, tiff, bmp or xpm to special-purpose formats such as fits or
 image formats found on some photo CDs. There are functions for finegrained
 image processing tasks, as well as conversion routines between the various
 image formats.
 .
 The GraphicsMagick library is a fork of ImageMagick and therefore offers
 an interface that is similar in features, but intended to be more stable
 across releases. While compatibility does not go so far that the
 GraphicsMagick library serves as a drop-in replacement for ImageMagick,
 conversion can usually be done with little effort.
 .
 This package contains the C++ development headers and library files needed to
 compile programs using the GraphicsMagick++ library.

Package: libgraphics-magick-perl
Architecture: any
Section: perl
Depends: ${perl:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: graphicsmagick-dbg
Description: format-independent image processing - perl interface
 GraphicsMagick provides libraries in several programming languages to read,
 write and manipulate image files across a large number of formats, from the
 widely used jpeg, tiff, bmp or xpm to special-purpose formats such as fits or
 image formats found on some photo CDs. There are functions for finegrained
 image processing tasks, as well as conversion routines between the various
 image formats.
 .
 The GraphicsMagick library is a fork of ImageMagick and therefore offers
 an interface that is similar in features, but intended to be more stable
 across releases. While compatibility does not go so far that the
 GraphicsMagick library serves as a drop-in replacement for ImageMagick,
 conversion can usually be done with little effort.
 .
 This package contains the classes to access GraphicsMagick functionality from
 Perl scripts. It is mostly similar to PerlMagick from the ImageMagick suite,
 but uses a different class name.

Package: graphicsmagick-imagemagick-compat
Architecture: all
Depends: graphicsmagick, ${misc:Depends}
Provides: imagemagick
Conflicts: imagemagick
Replaces: imagemagick
Description: image processing tools providing ImageMagick interface
 GraphicsMagick provides a set of command-line applications to manipulate
 image files. It is a fork of the ImageMagick project and therefore offers
 a similar set of features, but puts a larger emphasis on stability.
 .
 With this package installed, the GraphicsMagick command line tools can
 be executed like their ImageMagick counterparts. It allows one to migrate
 scripts from ImageMagick to GraphicsMagick without any code changes.

Package: graphicsmagick-libmagick-dev-compat
Architecture: all
Depends: libgraphicsmagick1-dev, libgraphicsmagick++1-dev, libgraphics-magick-perl, ${misc:Depends}
Provides: libmagick-dev, libmagick++-dev, perlmagick
Conflicts: libmagick-dev, libmagickcore-dev, libmagick6-dev, libmagick9-dev, libmagick++-dev, libmagick++6-dev, libmagick++9-dev, perlmagick
Replaces: libmagick-dev, libmagickcore-dev, libmagick6-dev, libmagick9-dev, libmagick++-dev, libmagick++6-dev, libmagick++9-dev, perlmagick
Description: image processing libraries providing ImageMagick interface
 GraphicsMagick provides libraries in several programming languages to read,
 write and manipulate image files across a large number of formats, from the
 widely used jpeg, tiff, bmp or xpm to special-purpose formats such as fits or
 image formats found on some photo CDs. There are functions for finegrained
 image processing tasks, as well as conversion routines between the various
 image formats.
 .
 The GraphicsMagick libraries are a fork of ImageMagick and therefore offer
 programming interfaces that are mostly compatible. While there might be
 small differences, experience tells that many programs only use a compatible
 subset and build fine with either GraphicsMagick or ImageMagick.
 .
 While GraphicsMagick uses different names for libraries, classes, and
 helper applications in order to coexist with ImageMagick, this package
 intends to minimise porting efforts by exporting the GraphicsMagick
 interface with the usual ImageMagick names. Note that this package only
 tries to provide build-time compatibility. Run-time libraries of
 ImageMagick and GraphicsMagick are incompatible and cannot be interchanged.
 .
 This package includes compatibility wrappers for the C, C++, and Perl
 libraries.

Package: graphicsmagick-dbg
Architecture: any
Section: debug
Depends: graphicsmagick (= ${binary:Version}), libgraphicsmagick-q16-3 (= ${binary:Version}), libgraphicsmagick++-q16-12 (= ${binary:Version}), libgraphics-magick-perl (= ${binary:Version}), ${misc:Depends}
Description: format-independent image processing - debugging symbols
 GraphicsMagick provides libraries in several programming languages to read,
 write and manipulate image files across a large number of formats, from the
 widely used jpeg, tiff, bmp or xpm to special-purpose formats such as fits or
 image formats found on some photo CDs. There are functions for finegrained
 image processing tasks, as well as conversion routines between the various
 image formats.
 .
 The GraphicsMagick library is a fork of ImageMagick and therefore offers
 an interface that is similar in features, but intended to be more stable
 across releases. While compatibility does not go so far that the
 GraphicsMagick library serves as a drop-in replacement for ImageMagick,
 conversion can usually be done with little effort.
 .
 This package contains debugging symbols for the gm executable as well as the
 C, C++, and Perl bindings. Tools like gdb and ltrace make use of these
 symbols.

## graphicsmagick 1.4+really1.3.39

=== debian/changelog ===
graphicsmagick (1.4+really1.3.39-2) unstable; urgency=medium

  * Backport security fix WritePCXImage(): Fix heap overflow when writing
    more than 1023 scenes, and also eliminate use of uninitialized memory.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 30 Dec 2022 23:25:30 +0100

graphicsmagick (1.4+really1.3.39-1) unstable; urgency=medium

  * New upstream release.
  * Enable JPEG XL format support (closes: #1026220).
  * Migrate gsfonts dependencies to fonts-urw-base35 (closes: #1020373).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 27 Dec 2022 08:32:14 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,8 @@
  x11proto-core-dev, libxml2-dev, libfreetype6-dev, libbz2-dev, libtiff-dev,
  libjbig-dev, libpng-dev, libwebp-dev, libheif-dev, zlib1g-dev | libz-dev,
  libzstd-dev, perl, ghostscript,
- gsfonts <!nocheck>,
+ libjxl-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el ia64 m68k riscv64 x32],
+ fonts-urw-base35 <!nocheck>,
  sharutils <!nocheck>
 Standards-Version: 4.5.1
 Rules-Requires-Root: dpkg/target-subcommand
@@ -43,7 +44,7 @@
 Depends: libtiff5 (>= 4.0.10), ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libgraphicsmagick3 (>= 1.3.21)
 Replaces: libgraphicsmagick3 (>= 1.3.21)
-Recommends: ghostscript, gsfonts
+Recommends: ghostscript, fonts-urw-base35
 Suggests: graphicsmagick-dbg
 Description: format-independent image processing - C shared library
  GraphicsMagick provides libraries in several programming languages to read,
@@ -70,6 +71,7 @@
  x11proto-core-dev, libxml2-dev, libfreetype6-dev, libtiff-dev (>= 4.0.10),
  libjbig-dev, libc6-dev, zlib1g-dev | libz-dev, libpng-dev, libheif-dev,
  libexif-dev, libbz2-dev, libltdl-dev, libwebp-dev, libzstd-dev, pkgconf,
+ libjxl-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el ia64 m68k riscv64 x32],
  ${misc:Depends}
 Breaks: libgraphicsmagick++1-dev (<< 1.3.21-2)
 Suggests: graphicsmagick
@@ -225,5 +227,3 @@
  conversion can usually be done with little effort.
  .
  This package contains debugging symbols for the gm executable as well as the
- C, C++, and Perl bindings. Tools like gdb and ltrace make use of these
- symbols.

## graphicsmagick 1.4+really1.3.40

=== debian/changelog ===
graphicsmagick (1.4+really1.3.40-4+deb12u1) bookworm-security; urgency=high

  * Non-maintainer upload by the Security Team.

  [ Carlos Henrique Lima Melara ]
  * d/p/CVE-2025-27795.patch: fix CVE-2025-27795 by adding image dimension
    resource limits. (Closes: #1099955)

  [ Salvatore Bonaccorso ]
  * ReadJXLImage(): pixel_format.num_channels needs to be 2 for grayscale
    matte (CVE-2025-32460)

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 11 Apr 2025 22:49:23 +0200

graphicsmagick (1.4+really1.3.40-4) unstable; urgency=medium

  * Remove development ifdef from memory leak fix.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 17 Apr 2023 19:17:10 +0200

graphicsmagick (1.4+really1.3.40-3) unstable; urgency=high

  * Backport security fixes:
    - MIFF reader able to provide attribute data in way which results in
      a heap overflow,
    - SetImageAttribute(): eliminate memory leak when handling attribute
      with key "EXIF:Orientation".

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 16 Apr 2023 14:21:32 +0200

graphicsmagick (1.4+really1.3.40-2) unstable; urgency=medium

  * Don't force tiff dependency, let shlibs handle it (closes: #1029212).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 19 Jan 2023 19:44:45 +0100

graphicsmagick (1.4+really1.3.40-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.6.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 15 Jan 2023 08:33:55 +0100

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,13 @@
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper-compat (= 13), pkgconf, libjpeg-dev, liblcms2-dev,
  libwmf-dev (>= 0.2.8.4), libx11-dev, libsm-dev, libice-dev, libxext-dev,
- x11proto-core-dev, libxml2-dev, libfreetype6-dev, libbz2-dev, libtiff-dev,
+ x11proto-core-dev, libxml2-dev, libfreetype-dev, libbz2-dev, libtiff-dev,
  libjbig-dev, libpng-dev, libwebp-dev, libheif-dev, zlib1g-dev | libz-dev,
  libzstd-dev, perl, ghostscript,
- libjxl-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el ia64 m68k riscv64 x32],
+ libjxl-dev [!alpha !hurd-i386],
  fonts-urw-base35 <!nocheck>,
  sharutils <!nocheck>
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Rules-Requires-Root: dpkg/target-subcommand
 Homepage: http://www.graphicsmagick.org/
 
@@ -41,7 +41,7 @@
 Package: libgraphicsmagick-q16-3
 Architecture: any
 Section: libs
-Depends: libtiff5 (>= 4.0.10), ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libgraphicsmagick3 (>= 1.3.21)
 Replaces: libgraphicsmagick3 (>= 1.3.21)
 Recommends: ghostscript, fonts-urw-base35
@@ -68,7 +68,7 @@
 Section: libdevel
 Depends: libgraphicsmagick-q16-3 (= ${binary:Version}), libjpeg-dev,
  liblcms2-dev, libwmf-dev, libx11-dev, libsm-dev, libice-dev, libxext-dev,
- x11proto-core-dev, libxml2-dev, libfreetype6-dev, libtiff-dev (>= 4.0.10),
+ x11proto-core-dev, libxml2-dev, libfreetype-dev, libtiff-dev,
  libjbig-dev, libc6-dev, zlib1g-dev | libz-dev, libpng-dev, libheif-dev,
  libexif-dev, libbz2-dev, libltdl-dev, libwebp-dev, libzstd-dev, pkgconf,
  libjxl-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el ia64 m68k riscv64 x32],
@@ -227,3 +227,5 @@
  conversion can usually be done with little effort.
  .
  This package contains debugging symbols for the gm executable as well as the
+ C, C++, and Perl bindings. Tools like gdb and ltrace make use of these
+ symbols.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
export DEB_HOST_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
        gm_confflags += --build $(DEB_HOST_GNU_TYPE)
else
	gm_confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

ARCHS_CHECK_NOFAIL:=hppa sparc
ifneq (,$(findstring $(DEB_BUILD_ARCH),$(ARCHS_CHECK_NOFAIL)))
CHECK_FAILED_ACTION:=echo "Ignoring testsuite failures on this architecture"
else
CHECK_FAILED_ACTION:= { \
		echo "Aborting build due to testsuite failures"; \
		if test -e test-suite.log; then \
			echo "==== test-suite.log ===="; \
			cat test-suite.log; \
			echo "==== end of test-suite.log ===="; \
		fi; \
		/bin/false; \
	}
endif

# on i386, with glibc-2.18, the linker hangs on i386
# $ cat test.c
# int main(){return(0);}
# $ gcc -fPIE -pie -static test.c
# *** Error in `/usr/bin/ld': corrupted double-linked list: 0x09da0260 ***
# <linker hangs>
ifneq (,$(filter $(DEB_HOST_ARCH),i386))
  DEB_BUILD_HARDENING_PIE:=0
endif

DEB_BUILD_MAINT_OPTIONS := hardening=+all
DPKG_EXPORT_BUILDFLAGS := 1
include /usr/share/dpkg/buildflags.mk

PACKAGENAME=graphicsmagick

configure: configure-stamp
configure-stamp:
	dh_testdir
	dh_autoreconf
	CFLAGS="$(CFLAGS)" CXXFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	MVDelegate=/bin/mv \
	    ./configure $(gm_confflags) \
		--enable-shared \
		--enable-static \
		--enable-libtool-verbose \
		--prefix=/usr \
		--mandir=\$${prefix}/share/man \
		--infodir=\$${prefix}/share/info \
		--docdir=\$${prefix}/share/doc/graphicsmagick \
		--with-gs-font-dir=/usr/share/fonts/type1/gsfonts \
		--with-x \
		--without-dps \
		--without-modules \
		--without-frozenpaths \
		--with-webp=yes \
		--with-zstd=yes \
		--with-perl \
		--with-perl-options="INSTALLDIRS=vendor" \
		--enable-quantum-library-names \
		--with-quantum-depth=16

	touch configure-stamp

build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp:  configure-stamp
	dh_testdir

	# Teach Perl binding to build without an installed library.
	# Also, we need to prune several of the security options we
	# added above:
	# * The compiler chokes on Perl's standard macro MEM_WRAP_CHECK()
	#   if -Werror=format-security is set.
	# * The Perl Makefile generator ignores linker flags it doesn't
	#   grok (ie. -pie -z relro). Hence, we need to strip -fPIE from
	#   CCFLAGS as well, or the linker would barf about non-PIC symbols.
	test -e PerlMagick/Makefile.PL.debsave || sed -i -e \
	 "/LIBS/s|\(-L[[:space:]]*\)[^[:space:]]\+|\1$(CURDIR)/magick/.libs|" \
	 -e "s/-Werror=format-security/-Wformat-security/g" \
	 -e "s/-fPIE//g" \
	 -e "s/-pie//g" \
	 PerlMagick/Makefile.PL

	$(MAKE)
	# Perl is built separately. Make sure to override the stupid
	# rpath picked up from the LIBS hack above.
	$(MAKE) perl-build LD_RUN_PATH=

	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp:  configure-stamp
	dh_testdir

	pod2man debian/Magick.pm > 'debian/Image::Magick.3pm'

	touch build-indep-stamp

check: check-stamp
check-stamp: build-arch-stamp
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_testdir

	# Cannot patch a binary file, so do take a detour via uudecode...
	for i in `cd "$(CURDIR)/debian/reference-new"; find -name "*.uu"`; do \
		new="$(CURDIR)/debian/reference-new/$$i"; \
		orig="$${i%.uu}"; \
		save="$(CURDIR)/debian/reference-orig/$${orig}"; \
		test -f "$${orig}" || continue; \
		test ! -f "$${save}" || continue; \
		mkdir -p "`dirname $${save}`" && \
		mv "$${orig}" "$${save}" && \
		uudecode -o "$${orig}" "$${new}"; \
	done

	# FIXME Something's confusing libtool, so its wrappers don't do the
	#       library path magic they are supposed to do. I haven't found
	#       out what's wrong yet, so let's work around the problem here
	#       with a manual override to LD_LIBRARY_PATH.
	# XXX make check insists on rebuilding the Perl plugin, so we have
	#     to override LD_RUN_PATH once more. (NB: We cannot just build
	#     the plugin once here because make check is not called when
	#     cross-compiling.)
	# XXX Unset DISPLAY to make sure the PerlMagick X regression test
	#     does not pick up a stray and possibly unauthenticated entry.
	@if test "$(DEB_HOST_GNU_TYPE)" = "$(DEB_BUILD_GNU_TYPE)"; then \
		unset DISPLAY; \
		LD_LIBRARY_PATH="$(CURDIR)/magick/.libs:$(CURDIR)/wand/.libs:$(CURDIR)/Magick++/lib/.libs:$$LD_LIBRARY_PATH" \
		$(MAKE) check check-perl LD_RUN_PATH= || \
		        $(CHECK_FAILED_ACTION); \
	else \
		echo "Skipping regression tests because we appear to be cross-compiling"; \
	fi
endif
	touch check-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f configure-stamp build-arch-stamp build-indep-stamp check-stamp

	test ! -f Makefile || $(MAKE) distclean distclean-perl
	rm -f $(CURDIR)/PerlMagick/Makefile.PL

	rm -f 'debian/Image::Magick.3pm'

	# Clean up after 'patching' miff binaries.
	test ! -d "$(CURDIR)/debian/reference-orig" || \
	for i in `cd "$(CURDIR)/debian/reference-orig"; find -type f`; do \
		orig="$${i}"; \
		save="$(CURDIR)/debian/reference-orig/$$i"; \
		mv "$${save}" "$${orig}"; \
	done && rm -rf "$(CURDIR)/debian/reference-orig"
	rm -f config.log

	dh_autoreconf_clean
	dh_clean

install: build install-indep install-arch
install-indep:
	dh_testdir
	dh_testroot
	
	dh_prep -i

	dh_install -i

install-arch:
	dh_testdir
	dh_testroot
	
	dh_prep -a

	# pkgdocdir is hardwired in configure.ac and can only be overridden
	# here.
	$(DEB_GAIN_ROOT_CMD) $(MAKE) install install-exec-perl \
		DESTDIR=$(CURDIR)/debian/tmp \
		pkgdocdir=/usr/share/doc/$(PACKAGENAME)

	# Push dependency libs to new .private entry.
	grep -q '^Libs.private:' \
		debian/tmp/usr/lib/pkgconfig/GraphicsMagick.pc || \
	  sed -e '/^Libs:/s|-L/usr/lib\(/X11\)\? ||g' \
	      -e '/^Libs:/s|\(-lGraphicsMagick\) \(.*\)|\1\nLibs.private: -L/usr/lib/X11 \2|' \
	      -i debian/tmp/usr/lib/pkgconfig/GraphicsMagick.pc

binary-indep: build-indep install-indep
	dh_testdir
	dh_testroot
	dh_installchangelogs -i
	dh_installdocs -i
	dh_installman -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build-arch check install-arch
	dh_testdir
	dh_testroot
	dh_installdirs -a
	mv debian/tmp/usr/share/doc/graphicsmagick/www/api* \
	   debian/libgraphicsmagick1-dev/usr/share/doc/libgraphicsmagick1-dev/www
	mv debian/tmp/usr/share/doc/graphicsmagick/www/Magick++/ \
	   debian/libgraphicsmagick++1-dev/usr/share/doc/libgraphicsmagick++1-dev/www
	sed -e 's|\(HREF="\)\(Magick++/\)|\1../../libgraphicsmagick++1-dev/www/\2|' \
	    -e 's|\(HREF="\)\(api.html\)|\1../../libgraphicsmagick1-dev/www/\2|' \
	    -i debian/tmp/usr/share/doc/graphicsmagick/www/programming.html
	dh_install -a --sourcedir=debian/tmp
	dh_missing -a --list-missing
	dh_installchangelogs -a ChangeLog
	dh_installdocs -a
	dh_installman -a
	dh_installexamples -a
	dh_installmenu -p graphicsmagick
	dh_installmime -p graphicsmagick
	dh_link -a
	dh_strip -a --dbg-package=graphicsmagick-dbg
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -Nlibgraphicsmagick++-q16-12
	dh_makeshlibs -plibgraphicsmagick++-q16-12 \
		-V'libgraphicsmagick++-q16-12 (>= 1.3.26-5~)'
	dh_installdeb -a
	dh_perl -p libgraphics-magick-perl
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-indep \
	install-arch

## graphicsmagick 1.4+really1.3.41

=== debian/changelog ===
graphicsmagick (1.4+really1.3.41-1) unstable; urgency=medium

  * New upstream release.
  * Use binary-targets for Rules-Requires-Root (closes: #1011774).
  * Update Standards-Version to 4.6.2 .
  * Update library symbols for this release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 15 Aug 2023 17:33:11 +0200

## graphicsmagick 1.4+really1.3.42

=== debian/changelog ===
graphicsmagick (1.4+really1.3.42-1) unstable; urgency=high

  * New upstream release, including many security fixes.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 24 Sep 2023 16:35:56 +0200

=== debian/control ===
--- 
+++ 
@@ -10,8 +10,8 @@
  libjxl-dev [!alpha !hurd-i386],
  fonts-urw-base35 <!nocheck>,
  sharutils <!nocheck>
-Standards-Version: 4.6.1
-Rules-Requires-Root: dpkg/target-subcommand
+Standards-Version: 4.6.2
+Rules-Requires-Root: binary-targets
 Homepage: http://www.graphicsmagick.org/
 
 Package: graphicsmagick

## graphicsmagick 1.4+really1.3.43

=== debian/changelog ===
graphicsmagick (1.4+really1.3.43-1deepin1) unstable; urgency=medium

  * revert 64-bit time_t transition patch.

 -- lichenggang <lichenggang@deepin.org>  Fri, 18 Oct 2024 14:53:25 +0800

graphicsmagick (1.4+really1.3.43-1) unstable; urgency=high

  * New upstream release, including many security fixes.
  * Update library symbols for this release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 24 Mar 2024 20:46:14 +0100

graphicsmagick (1.4+really1.3.42-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063117

 -- Benjamin Drung <bdrung@debian.org>  Fri, 01 Mar 2024 12:05:32 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: graphics
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper-compat (= 13), pkgconf, libjpeg-dev, liblcms2-dev,
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), pkgconf, libjpeg-dev, liblcms2-dev,
  libwmf-dev (>= 0.2.8.4), libx11-dev, libsm-dev, libice-dev, libxext-dev,
  x11proto-core-dev, libxml2-dev, libfreetype-dev, libbz2-dev, libtiff-dev,
  libjbig-dev, libpng-dev, libwebp-dev, libheif-dev, zlib1g-dev | libz-dev,
@@ -39,11 +39,12 @@
  that is compatible to ImageMagick's interface.
 
 Package: libgraphicsmagick-q16-3
+Breaks: libgraphicsmagick-q16-3 (<< ${source:Version})
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libgraphicsmagick3 (>= 1.3.21)
-Replaces: libgraphicsmagick3 (>= 1.3.21)
+Replaces: libgraphicsmagick-q16-3, libgraphicsmagick3 (>= 1.3.21)
 Recommends: ghostscript, fonts-urw-base35
 Suggests: graphicsmagick-dbg
 Description: format-independent image processing - C shared library
@@ -98,8 +99,8 @@
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libgraphicsmagick++-q16-11 (= 1.3.22-1)
-Replaces: libgraphicsmagick++-q16-11 (= 1.3.22-1)
-Breaks: python-pgmagick (<= 0.7.4-1), python3-pgmagick (<= 0.7.4-1), libgnudatalanguage0 (<= 0.9.9-9)
+Replaces: libgraphicsmagick++-q16-12, libgraphicsmagick++-q16-11 (= 1.3.22-1)
+Breaks: libgraphicsmagick++-q16-12 (<< ${source:Version}), python-pgmagick (<= 0.7.4-1), python3-pgmagick (<= 0.7.4-1), libgnudatalanguage0 (<= 0.9.9-9)
 Suggests: graphicsmagick-dbg
 Description: format-independent image processing - C++ shared library
  GraphicsMagick provides libraries in several programming languages to read,
@@ -226,6 +227,3 @@
  GraphicsMagick library serves as a drop-in replacement for ImageMagick,
  conversion can usually be done with little effort.
  .
- This package contains debugging symbols for the gm executable as well as the
- C, C++, and Perl bindings. Tools like gdb and ltrace make use of these
- symbols.

## graphicsmagick 1.4+really1.3.44

=== debian/changelog ===
graphicsmagick (1.4+really1.3.44-1) unstable; urgency=high

  * New upstream release, including many security fixes.
  * Update library symbols for this release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 25 Aug 2024 13:05:43 +0200

## graphicsmagick 1.4+really1.3.45

=== debian/changelog ===
graphicsmagick (1.4+really1.3.45-1ubuntu0.1) oracular-security; urgency=medium

  * SECURITY UPDATE: Excessive Memory Consumption
    - debian/patches/CVE-2025-27795.patch: Add check for image dimensions
    - CVE-2025-27795
  * SECURITY UPDATE: Out-of-bounds Access
    - debian/patches/CVE-2025-27796.patch: Ensure buffer is properly 
      allocated
    - CVE-2025-27796

 -- Bruce Cable <bruce.cable@canonical.com>  Fri, 11 Apr 2025 18:37:03 +1000

graphicsmagick (1.4+really1.3.45-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.7.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 29 Aug 2024 17:04:48 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: graphicsmagick
 Section: graphics
 Priority: optional
-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), pkgconf, libjpeg-dev, liblcms2-dev,
  libwmf-dev (>= 0.2.8.4), libx11-dev, libsm-dev, libice-dev, libxext-dev,
  x11proto-core-dev, libxml2-dev, libfreetype-dev, libbz2-dev, libtiff-dev,
@@ -10,7 +11,7 @@
  libjxl-dev [!alpha !hurd-i386],
  fonts-urw-base35 <!nocheck>,
  sharutils <!nocheck>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: binary-targets
 Homepage: http://www.graphicsmagick.org/
 
@@ -38,7 +39,8 @@
  graphicsmagick-imagemagick-compat to obtain a set of several executables
  that is compatible to ImageMagick's interface.
 
-Package: libgraphicsmagick-q16-3
+Package: libgraphicsmagick-q16-3t64
+Provides: ${t64:Provides}
 Breaks: libgraphicsmagick-q16-3 (<< ${source:Version})
 Architecture: any
 Section: libs
@@ -67,7 +69,7 @@
 Package: libgraphicsmagick1-dev
 Architecture: any
 Section: libdevel
-Depends: libgraphicsmagick-q16-3 (= ${binary:Version}), libjpeg-dev,
+Depends: libgraphicsmagick-q16-3t64 (= ${binary:Version}), libjpeg-dev,
  liblcms2-dev, libwmf-dev, libx11-dev, libsm-dev, libice-dev, libxext-dev,
  x11proto-core-dev, libxml2-dev, libfreetype-dev, libtiff-dev,
  libjbig-dev, libc6-dev, zlib1g-dev | libz-dev, libpng-dev, libheif-dev,
@@ -94,7 +96,8 @@
  This package contains the C development headers and library files needed to
  compile programs using the GraphicsMagick library.
 
-Package: libgraphicsmagick++-q16-12
+Package: libgraphicsmagick++-q16-12t64
+Provides: ${t64:Provides}
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -122,7 +125,7 @@
 Package: libgraphicsmagick++1-dev
 Architecture: any
 Section: libdevel
-Depends: libgraphicsmagick++-q16-12 (= ${binary:Version}), libgraphicsmagick1-dev, ${misc:Depends}
+Depends: libgraphicsmagick++-q16-12t64 (= ${binary:Version}), libgraphicsmagick1-dev, ${misc:Depends}
 Suggests: graphicsmagick
 Provides: libgraphicsmagick++-dev
 Description: format-independent image processing - C++ development files
@@ -212,7 +215,7 @@
 Package: graphicsmagick-dbg
 Architecture: any
 Section: debug
-Depends: graphicsmagick (= ${binary:Version}), libgraphicsmagick-q16-3 (= ${binary:Version}), libgraphicsmagick++-q16-12 (= ${binary:Version}), libgraphics-magick-perl (= ${binary:Version}), ${misc:Depends}
+Depends: graphicsmagick (= ${binary:Version}), libgraphicsmagick-q16-3t64 (= ${binary:Version}), libgraphicsmagick++-q16-12t64 (= ${binary:Version}), libgraphics-magick-perl (= ${binary:Version}), ${misc:Depends}
 Description: format-independent image processing - debugging symbols
  GraphicsMagick provides libraries in several programming languages to read,
  write and manipulate image files across a large number of formats, from the
@@ -224,6 +227,3 @@
  The GraphicsMagick library is a fork of ImageMagick and therefore offers
  an interface that is similar in features, but intended to be more stable
  across releases. While compatibility does not go so far that the
- GraphicsMagick library serves as a drop-in replacement for ImageMagick,
- conversion can usually be done with little effort.
- .

## graphicsmagick 1.4+really1.3.45+hg17689

=== PerlMagick/demo/Makefile ===
all:
	perl demo.pl
	perl button.pl
	perl shapes.pl
	perl piddle.pl
	perl tree.pl
	perl steganography.pl
	perl shadow_text.pl
	perl annotate.pl
	perl composite.pl

clean:
	/bin/rm -f demo.jpg button.gif model.png shadow.gif tree.gif

=== debian/changelog ===
graphicsmagick (1.4+really1.3.45+hg17689-1) unstable; urgency=high

  * Mercurial snapshot, fixing the following security issues:
    - CVE-2025-27795: ReadJXLImage(): Apply image dimension resource limits
      (closes: #1099955),
    - CVE-2025-27796: ReadWPGImage(): Assure that palette buffer is allocated
      and the current size (closes: #1099954).
  * Update Standards-Version to 4.7.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 11 Mar 2025 17:32:20 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: graphicsmagick
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), pkgconf, libjpeg-dev, liblcms2-dev,
  libwmf-dev (>= 0.2.8.4), libx11-dev, libsm-dev, libice-dev, libxext-dev,
  x11proto-core-dev, libxml2-dev, libfreetype-dev, libbz2-dev, libtiff-dev,
@@ -11,7 +10,7 @@
  libjxl-dev [!alpha !hurd-i386],
  fonts-urw-base35 <!nocheck>,
  sharutils <!nocheck>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: binary-targets
 Homepage: http://www.graphicsmagick.org/
 
@@ -227,3 +226,4 @@
  The GraphicsMagick library is a fork of ImageMagick and therefore offers
  an interface that is similar in features, but intended to be more stable
  across releases. While compatibility does not go so far that the
+ GraphicsMagick library serves as a drop-in replacement for ImageMagick,

=== debian/watch ===
version=4
opts=dversionmangle=s/1.4\+really//,\
pgpsigurlmangle=s/$/.asc/ \
https://qa.debian.org/watch/sf.php/graphicsmagick/ \
(?:|.*/)GraphicsMagick(?:[_\-]v?|)(\d\.\d+\.[1-9]+|\d\.\d+)@ARCHIVE_EXT@

## graphicsmagick 1.4+really1.3.45+hg17692

=== debian/changelog ===
graphicsmagick (1.4+really1.3.45+hg17692-1) unstable; urgency=high

  * Mercurial snapshot, fixing the following security issues:
    - disable EXPERIMENTAL_EXIF_TAGS by default until libtiff API weaknesses
      are resolved,
    - AddIFDExifFields(): check for overflow of computed unsigned value.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 23 Mar 2025 16:36:39 +0100

## graphicsmagick 1.4+really1.3.45+hg17696

=== debian/changelog ===
graphicsmagick (1.4+really1.3.45+hg17696-1deepin1) unstable; urgency=medium

  * Strip t64

 -- Cryolitia <liziyao@uniontech.com>  Thu, 24 Apr 2025 14:17:26 +0800

graphicsmagick (1.4+really1.3.45+hg17696-1) unstable; urgency=high

  * Mercurial snapshot, fixing the following security issue:
    - ReadJXLImage(): heap-buffer-overflow in ImportViewPixelArea() .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 07 Apr 2025 17:37:00 +0200

=== debian/control ===
--- 
+++ 
@@ -38,14 +38,12 @@
  graphicsmagick-imagemagick-compat to obtain a set of several executables
  that is compatible to ImageMagick's interface.
 
-Package: libgraphicsmagick-q16-3t64
-Provides: ${t64:Provides}
-Breaks: libgraphicsmagick-q16-3 (<< ${source:Version})
+Package: libgraphicsmagick-q16-3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libgraphicsmagick3 (>= 1.3.21)
-Replaces: libgraphicsmagick-q16-3, libgraphicsmagick3 (>= 1.3.21)
+Replaces: libgraphicsmagick3 (>= 1.3.21)
 Recommends: ghostscript, fonts-urw-base35
 Suggests: graphicsmagick-dbg
 Description: format-independent image processing - C shared library
@@ -68,7 +66,7 @@
 Package: libgraphicsmagick1-dev
 Architecture: any
 Section: libdevel
-Depends: libgraphicsmagick-q16-3t64 (= ${binary:Version}), libjpeg-dev,
+Depends: libgraphicsmagick-q16-3 (= ${binary:Version}), libjpeg-dev,
  liblcms2-dev, libwmf-dev, libx11-dev, libsm-dev, libice-dev, libxext-dev,
  x11proto-core-dev, libxml2-dev, libfreetype-dev, libtiff-dev,
  libjbig-dev, libc6-dev, zlib1g-dev | libz-dev, libpng-dev, libheif-dev,
@@ -95,14 +93,13 @@
  This package contains the C development headers and library files needed to
  compile programs using the GraphicsMagick library.
 
-Package: libgraphicsmagick++-q16-12t64
-Provides: ${t64:Provides}
+Package: libgraphicsmagick++-q16-12
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libgraphicsmagick++-q16-11 (= 1.3.22-1)
-Replaces: libgraphicsmagick++-q16-12, libgraphicsmagick++-q16-11 (= 1.3.22-1)
-Breaks: libgraphicsmagick++-q16-12 (<< ${source:Version}), python-pgmagick (<= 0.7.4-1), python3-pgmagick (<= 0.7.4-1), libgnudatalanguage0 (<= 0.9.9-9)
+Replaces: libgraphicsmagick++-q16-11 (= 1.3.22-1)
+Breaks: python-pgmagick (<= 0.7.4-1), python3-pgmagick (<= 0.7.4-1), libgnudatalanguage0 (<= 0.9.9-9)
 Suggests: graphicsmagick-dbg
 Description: format-independent image processing - C++ shared library
  GraphicsMagick provides libraries in several programming languages to read,
@@ -124,7 +121,7 @@
 Package: libgraphicsmagick++1-dev
 Architecture: any
 Section: libdevel
-Depends: libgraphicsmagick++-q16-12t64 (= ${binary:Version}), libgraphicsmagick1-dev, ${misc:Depends}
+Depends: libgraphicsmagick++-q16-12 (= ${binary:Version}), libgraphicsmagick1-dev, ${misc:Depends}
 Suggests: graphicsmagick
 Provides: libgraphicsmagick++-dev
 Description: format-independent image processing - C++ development files
@@ -214,7 +211,7 @@
 Package: graphicsmagick-dbg
 Architecture: any
 Section: debug
-Depends: graphicsmagick (= ${binary:Version}), libgraphicsmagick-q16-3t64 (= ${binary:Version}), libgraphicsmagick++-q16-12t64 (= ${binary:Version}), libgraphics-magick-perl (= ${binary:Version}), ${misc:Depends}
+Depends: graphicsmagick (= ${binary:Version}), libgraphicsmagick-q16-3 (= ${binary:Version}), libgraphicsmagick++-q16-12 (= ${binary:Version}), libgraphics-magick-perl (= ${binary:Version}), ${misc:Depends}
 Description: format-independent image processing - debugging symbols
  GraphicsMagick provides libraries in several programming languages to read,
  write and manipulate image files across a large number of formats, from the
@@ -227,3 +224,8 @@
  an interface that is similar in features, but intended to be more stable
  across releases. While compatibility does not go so far that the
  GraphicsMagick library serves as a drop-in replacement for ImageMagick,
+ conversion can usually be done with little effort.
+ .
+ This package contains debugging symbols for the gm executable as well as the
+ C, C++, and Perl bindings. Tools like gdb and ltrace make use of these
+ symbols.
